package com.jakubu9333.grammarManager.model;

import com.fasterxml.jackson.annotation.JsonView;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.SequenceGenerator;
import java.util.Objects;

/**
 * @author Jakub Uhlarik
 */

@Entity
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
public class RightSidePart {

    @Id
    @JsonView(View.All.class)
    @SequenceGenerator(name = "rule_sequence", allocationSize = 1, sequenceName = "rule_sequence")
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "rule_sequence")
    private Long id;

    @JsonView(View.All.class)
    private String part;

    public RightSidePart(String part) {
        this.part = part;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        RightSidePart that = (RightSidePart) o;
        return Objects.equals(part, that.part);
    }

    @Override
    public int hashCode() {
        return Objects.hash(part);
    }
}
